# sbvar.py - common global variable declarations and default values
#
#    Copyright (C) 2015 Anders Lind, Erding Mallards e.V.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Global variable initialization module
# Defines all global variables with default values
# Must be imported by all modules dealing with any of the variables
# 
# Each variable is then pre-pended with "sbvar". Example:
# Global variable "counter_G1" is referenced as "sbvar.counter_G1".

########################################################################
# Counters - holding the current game results
# Guest inning counters:
counter_G1 = 0
counter_G2 = 0
counter_G3 = 0
counter_G4 = 0
counter_G5 = 0
counter_G6 = 0
counter_G7 = 0
counter_G8 = 0
counter_G9 = 0
counter_GX = 0
# Home inning counters:
counter_H1 = 0
counter_H2 = 0
counter_H3 = 0
counter_H4 = 0
counter_H5 = 0
counter_H6 = 0
counter_H7 = 0
counter_H8 = 0
counter_H9 = 0
counter_HX = 0
# Error counters:
counter_GE = 0
counter_HE = 0
# Runs counters:
counter_GR = 0
counter_HR = 0
# Hits counters: 
counter_GH = 0
counter_HH = 0
# Outs, balls, strikes counters:
counter_OUTS = 0
counter_BALLS = 0
counter_STRIKES = 0

########################################################################
# Visibility flags - 0 = digit is hidden, 1 = digit is displayed
# Guest inning flags:
show_G1 = 0
show_G2 = 0
show_G3 = 0
show_G4 = 0
show_G5 = 0
show_G6 = 0
show_G7 = 0
show_G8 = 0
show_G9 = 0
show_GX = 0
# Home inning flags:
show_H1 = 0
show_H2 = 0
show_H3 = 0
show_H4 = 0
show_H5 = 0
show_H6 = 0
show_H7 = 0
show_H8 = 0
show_H9 = 0
show_HX = 0
# Error flags:
show_GE = 0
show_HE = 0
# Runs flags:
show_GR = 0
show_HR = 0
# Hits flags:
show_GH = 0
show_HH = 0
# Outs, balls, strikes counters:
show_OUTS = 0
show_BALLS = 0
show_STRIKES = 0
# Colon (when displaying the time)
show_COLON = 0

########################################################################
# Current inning counter:
counter_INNING = 0

########################################################################
# Current display mode:
# 0 = Time mode
# 1 = Baseball mode
# 2 = Teeball mode
# 3 = Startup message
display_mode = 3

########################################################################
# Debug mode switch:
debug_mode = 0
# Debug color codes:
col_fs = '\033[1;37m' # Bright white
col_fe = '\033[1;33m' # Bright yellow
col_wa = '\033[1;35m' # Bright cyan
col_er = '\033[1;30;40m' # Bright red inverted
col_n  = '\033[0;37m' # Normal white
col_t  = '\033[2;32m' # Faint green
# END OF FILE