//    Copyright (C) 2015 Anders Lind, Erding Mallards e.V.
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

webiopi().ready(function() {
	// ###################################################################################
	// ############################# Main controls section ###############################
	// ###################################################################################

	// ############################## Inning Buttons #####################################
	var inningContent;
	inningContent = $("#inningContent");

	// Update the current inning label
	webiopi().callMacro("get_inning_label", [], getInningLabel);

	// Inning increment button
	var inningPlusButton = webiopi().createButton("InningUp", "Inning +", function() {
		webiopi().callMacro("update_inning_count",'up');
		webiopi().callMacro("get_inning_label", [], getInningLabel);
	});
	inningContent.append(inningPlusButton);

	// Dummy button to hold the current image label
	var showInningButton = webiopi().createButton("CurrInning", "---", getInningLabel);
	inningContent.append(showInningButton);

	// Inning decrement button
	var inningMinusButton = webiopi().createButton("InningDown", "Inning –", function() {
		webiopi().callMacro("update_inning_count",'down');
		webiopi().callMacro("get_inning_label", [], getInningLabel);
	});
	inningContent.append(inningMinusButton);

	// Functions needed by the inning label text
	function getInningLabel() {
		webiopi().callMacro("get_inning_label",[],setInningLabel);
	}
	function setInningLabel(macro, args, data) {
		webiopi().setLabel("CurrInning", data);
	}


	// ################################ Run Buttons #######################################
	var runContent;
	runContent = $("#runContent");

	// Run increment button
	var runPlusButton = webiopi().createButton("RunUp", "RUN", function() {
		webiopi().callMacro("update_inning_runs",'up');
		webiopi().callMacro("get_counter_value", 'G1', getRunsG1);
		webiopi().callMacro("get_counter_value", 'G2', getRunsG2);
		webiopi().callMacro("get_counter_value", 'G3', getRunsG3);
		webiopi().callMacro("get_counter_value", 'G4', getRunsG4);
		webiopi().callMacro("get_counter_value", 'G5', getRunsG5);
		webiopi().callMacro("get_counter_value", 'G6', getRunsG6);
		webiopi().callMacro("get_counter_value", 'G7', getRunsG7);
		webiopi().callMacro("get_counter_value", 'G8', getRunsG8);
		webiopi().callMacro("get_counter_value", 'G9', getRunsG9);
		webiopi().callMacro("get_counter_value", 'GX', getRunsGX);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
		webiopi().callMacro("get_counter_value", 'H1', getRunsH1);
		webiopi().callMacro("get_counter_value", 'H2', getRunsH2);
		webiopi().callMacro("get_counter_value", 'H3', getRunsH3);
		webiopi().callMacro("get_counter_value", 'H4', getRunsH4);
		webiopi().callMacro("get_counter_value", 'H5', getRunsH5);
		webiopi().callMacro("get_counter_value", 'H6', getRunsH6);
		webiopi().callMacro("get_counter_value", 'H7', getRunsH7);
		webiopi().callMacro("get_counter_value", 'H8', getRunsH8);
		webiopi().callMacro("get_counter_value", 'H9', getRunsH9);
		webiopi().callMacro("get_counter_value", 'HX', getRunsHX);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	runContent.append(runPlusButton);

	// Run decrement button
	var runMinusButton = webiopi().createButton("RunDown", "—", function() {
		webiopi().callMacro("update_inning_runs",'down');
		webiopi().callMacro("get_counter_value", 'G1', getRunsG1);
		webiopi().callMacro("get_counter_value", 'G2', getRunsG2);
		webiopi().callMacro("get_counter_value", 'G3', getRunsG3);
		webiopi().callMacro("get_counter_value", 'G4', getRunsG4);
		webiopi().callMacro("get_counter_value", 'G5', getRunsG5);
		webiopi().callMacro("get_counter_value", 'G6', getRunsG6);
		webiopi().callMacro("get_counter_value", 'G7', getRunsG7);
		webiopi().callMacro("get_counter_value", 'G8', getRunsG8);
		webiopi().callMacro("get_counter_value", 'G9', getRunsG9);
		webiopi().callMacro("get_counter_value", 'GX', getRunsGX);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
		webiopi().callMacro("get_counter_value", 'H1', getRunsH1);
		webiopi().callMacro("get_counter_value", 'H2', getRunsH2);
		webiopi().callMacro("get_counter_value", 'H3', getRunsH3);
		webiopi().callMacro("get_counter_value", 'H4', getRunsH4);
		webiopi().callMacro("get_counter_value", 'H5', getRunsH5);
		webiopi().callMacro("get_counter_value", 'H6', getRunsH6);
		webiopi().callMacro("get_counter_value", 'H7', getRunsH7);
		webiopi().callMacro("get_counter_value", 'H8', getRunsH8);
		webiopi().callMacro("get_counter_value", 'H9', getRunsH9);
		webiopi().callMacro("get_counter_value", 'HX', getRunsHX);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	runContent.append(runMinusButton);


	//  ################################ Hit Buttons #######################################
	var hitContent;
	hitContent = $("#hitContent");

	// Hit increment button
	var hitPlusButton = webiopi().createButton("HitUp", "HIT", function() {
		webiopi().callMacro("update_hits_count",'up');
		webiopi().callMacro("get_counter_value", 'GH', getHitsG);
		webiopi().callMacro("get_counter_value", 'HH', getHitsH);
	});
	hitContent.append(hitPlusButton);

	// Hit decrement button
	var hitMinusButton = webiopi().createButton("HitDown", "—", function() {
		webiopi().callMacro("update_hits_count",'down');
		webiopi().callMacro("get_counter_value", 'GH', getHitsG);
		webiopi().callMacro("get_counter_value", 'HH', getHitsH);
	});
	hitContent.append(hitMinusButton);

	//  ############################## Errors Buttons ######################################
	var errContent;
	errContent = $("#errContent");

	// Error increment button
	var errPlusButton = webiopi().createButton("ErrUp", "ERR", function() {
		webiopi().callMacro("update_error_count",'up');
		webiopi().callMacro("get_counter_value", 'GE', getErrorsG);
		webiopi().callMacro("get_counter_value", 'HE', getErrorsH);
	});
	errContent.append(errPlusButton);

	// Error decrement button
	var errMinusButton = webiopi().createButton("ErrDown", "—", function() {
		webiopi().callMacro("update_error_count",'down');
		webiopi().callMacro("get_counter_value", 'GE', getErrorsG);
		webiopi().callMacro("get_counter_value", 'HE', getErrorsH);
	});
	errContent.append(errMinusButton);

	//  ############################### Balls Button #######################################
	var ballContent;
	ballContent = $("#ballContent");

	// Balls increment button
	var ballButton = webiopi().createButton("Ball", "BALL", function() {
		webiopi().callMacro("update_balls_count",[]);
		webiopi().callMacro("get_counter_value", 'BALLS', setBalls);
	});
	ballContent.append(ballButton);

	function setBalls(macro, args, data) {
		if (data == "0") {
			$("#showBallsButton1").attr("class", "off");
			$("#showBallsButton2").attr("class", "off");
			$("#showBallsButton3").attr("class", "off");
		} else if (data == "1") {
			$("#showBallsButton1").attr("class", "on");
			$("#showBallsButton2").attr("class", "off");
			$("#showBallsButton3").attr("class", "off");
		} else if (data == "2") {
			$("#showBallsButton1").attr("class", "on");
			$("#showBallsButton2").attr("class", "on");
			$("#showBallsButton3").attr("class", "off");
		} else if (data == "3") {
			$("#showBallsButton1").attr("class", "on");
			$("#showBallsButton2").attr("class", "on");
			$("#showBallsButton3").attr("class", "on");
		}
	}

	//  ############################### Strikes Button #####################################
	var strikesContent;
	strikesContent = $("#strikesContent");

	// Strikes increment button
	var strikesButton = webiopi().createButton("Strike", "STRIKE", function() {
		webiopi().callMacro("update_strikes_count",[]);
		webiopi().callMacro("get_counter_value", 'STRIKES', setStrikes);
	});
	strikesContent.append(strikesButton);

	function setStrikes(macro, args, data) {
		if (data == "0") {
			$("#showStrikesButton1").attr("class", "off");
			$("#showStrikesButton2").attr("class", "off");
		} else if (data == "1") {
			$("#showStrikesButton1").attr("class", "on");
			$("#showStrikesButton2").attr("class", "off");
		} else if (data == "2") {
			$("#showStrikesButton1").attr("class", "on");
			$("#showStrikesButton2").attr("class", "on");
		}
	}

	//  ############################# Next Batter Button ###################################
	var nextBatterContent;
	nextBatterContent = $("#nextBatterContent");

	// Next Batter button
	var nextBatterButton = webiopi().createButton("NextBatter", "NEXT BATTER", function() {
		webiopi().callMacro("next_batter",[]);
		webiopi().callMacro("get_counter_value", 'BALLS', setBalls);
		webiopi().callMacro("get_counter_value", 'STRIKES', setStrikes);
	});
	nextBatterContent.append(nextBatterButton);

	//  ############################### Outs Buttons #######################################
	var outsContent;
	outsContent = $("#outsContent");

	// Outs increment button
	var outsPlusButton = webiopi().createButton("OutUp", "OUT", function() {
		webiopi().callMacro("update_outs_count",[]);
		webiopi().callMacro("get_counter_value", 'OUTS', setOuts);
	});
	outsContent.append(outsPlusButton);

	function setOuts(macro, args, data) {
		if (data == "0") {
			$("#showOutsButton1").attr("class", "off");
			$("#showOutsButton2").attr("class", "off");
		} else if (data == "1") {
			$("#showOutsButton1").attr("class", "on");
			$("#showOutsButton2").attr("class", "off");
		} else if (data == "2") {
			$("#showOutsButton1").attr("class", "on");
			$("#showOutsButton2").attr("class", "on");
		}
	}

	// #####################################################################################
	// ########################### Detailed scoreboard section #############################
	// #####################################################################################

	// ############################### Runs Gast, 1. Inning ################################

	var contentG1;
	contentG1 = $("#contentG1");

	var runsG1_PlusButton = webiopi().createButton("RunsG1Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G1','up']);
		webiopi().callMacro("get_counter_value", 'G1', getRunsG1);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG1.append(runsG1_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG1Button = webiopi().createButton("RunsG1", "---", getRunsG1);
	contentG1.append(showRunsG1Button);
	
	var runsG1_MinusButton = webiopi().createButton("RunsG1Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G1','down']);
		webiopi().callMacro("get_counter_value", 'G1', getRunsG1);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG1.append(runsG1_MinusButton);

	// Functions needed by the current runs text
	function getRunsG1() {
		webiopi().callMacro("get_counter_value", 'G1', setRunsG1);
	}
	function setRunsG1(macro, args, data) {
		webiopi().setLabel("RunsG1", data);
	}

	// ############################### Runs Gast, 2. Inning ################################

	var contentG2;
	contentG2 = $("#contentG2");

	var runsG2_PlusButton = webiopi().createButton("RunsG2Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G2','up']);
		webiopi().callMacro("get_counter_value", 'G2', getRunsG2);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG2.append(runsG2_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG2Button = webiopi().createButton("RunsG2", "---", getRunsG2);
	contentG2.append(showRunsG2Button);
	
	var runsG2_MinusButton = webiopi().createButton("RunsG2Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G2','down']);
		webiopi().callMacro("get_counter_value", 'G2', getRunsG2);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG2.append(runsG2_MinusButton);

	// Functions needed by the current runs text
	function getRunsG2() {
		webiopi().callMacro("get_counter_value", 'G2', setRunsG2);
	}
	function setRunsG2(macro, args, data) {
		webiopi().setLabel("RunsG2", data);
	}

	// ############################### Runs Gast, 3. Inning ################################

	var contentG3;
	contentG3 = $("#contentG3");

	var runsG3_PlusButton = webiopi().createButton("RunsG3Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G3','up']);
		webiopi().callMacro("get_counter_value", 'G3', getRunsG3);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG3.append(runsG3_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG3Button = webiopi().createButton("RunsG3", "---", getRunsG3);
	contentG3.append(showRunsG3Button);
	
	var runsG3_MinusButton = webiopi().createButton("RunsG3Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G3','down']);
		webiopi().callMacro("get_counter_value", 'G3', getRunsG3);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG3.append(runsG3_MinusButton);

	// Functions needed by the current runs text
	function getRunsG3() {
		webiopi().callMacro("get_counter_value", 'G3', setRunsG3);
	}
	function setRunsG3(macro, args, data) {
		webiopi().setLabel("RunsG3", data);
	}

	// ############################### Runs Gast, 4. Inning ################################

	var contentG4;
	contentG4 = $("#contentG4");

	var runsG4_PlusButton = webiopi().createButton("RunsG4Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G4','up']);
		webiopi().callMacro("get_counter_value", 'G4', getRunsG4);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG4.append(runsG4_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG4Button = webiopi().createButton("RunsG4", "---", getRunsG4);
	contentG4.append(showRunsG4Button);
	
	var runsG4_MinusButton = webiopi().createButton("RunsG4Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G4','down']);
		webiopi().callMacro("get_counter_value", 'G4', getRunsG4);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG4.append(runsG4_MinusButton);

	// Functions needed by the current runs text
	function getRunsG4() {
		webiopi().callMacro("get_counter_value", 'G4', setRunsG4);
	}
	function setRunsG4(macro, args, data) {
		webiopi().setLabel("RunsG4", data);
	}

	// ############################### Runs Gast, 5. Inning ################################

	var contentG5;
	contentG5 = $("#contentG5");

	var runsG5_PlusButton = webiopi().createButton("RunsG5Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G5','up']);
		webiopi().callMacro("get_counter_value", 'G5', getRunsG5);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG5.append(runsG5_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG5Button = webiopi().createButton("RunsG5", "---", getRunsG5);
	contentG5.append(showRunsG5Button);
	
	var runsG5_MinusButton = webiopi().createButton("RunsG5Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G5','down']);
		webiopi().callMacro("get_counter_value", 'G5', getRunsG5);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG5.append(runsG5_MinusButton);

	// Functions needed by the current runs text
	function getRunsG5() {
		webiopi().callMacro("get_counter_value", 'G5', setRunsG5);
	}
	function setRunsG5(macro, args, data) {
		webiopi().setLabel("RunsG5", data);
	}

	// ############################### Runs Gast, 6. Inning ################################

	var contentG6;
	contentG6 = $("#contentG6");

	var runsG6_PlusButton = webiopi().createButton("RunsG6Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G6','up']);
		webiopi().callMacro("get_counter_value", 'G6', getRunsG6);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG6.append(runsG6_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG6Button = webiopi().createButton("RunsG6", "---", getRunsG6);
	contentG6.append(showRunsG6Button);
	
	var runsG6_MinusButton = webiopi().createButton("RunsG6Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G6','down']);
		webiopi().callMacro("get_counter_value", 'G6', getRunsG6);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG6.append(runsG6_MinusButton);

	// Functions needed by the current runs text
	function getRunsG6() {
		webiopi().callMacro("get_counter_value", 'G6', setRunsG6);
	}
	function setRunsG6(macro, args, data) {
		webiopi().setLabel("RunsG6", data);
	}

	// ############################### Runs Gast, 7. Inning ################################

	var contentG7;
	contentG7 = $("#contentG7");

	var runsG7_PlusButton = webiopi().createButton("RunsG7Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G7','up']);
		webiopi().callMacro("get_counter_value", 'G7', getRunsG7);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG7.append(runsG7_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG7Button = webiopi().createButton("RunsG7", "---", getRunsG7);
	contentG7.append(showRunsG7Button);
	
	var runsG7_MinusButton = webiopi().createButton("RunsG7Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G7','down']);
		webiopi().callMacro("get_counter_value", 'G7', getRunsG7);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG7.append(runsG7_MinusButton);

	// Functions needed by the current runs text
	function getRunsG7() {
		webiopi().callMacro("get_counter_value", 'G7', setRunsG7);
	}
	function setRunsG7(macro, args, data) {
		webiopi().setLabel("RunsG7", data);
	}

	// ############################### Runs Gast, 8. Inning ################################

	var contentG8;
	contentG8 = $("#contentG8");

	var runsG8_PlusButton = webiopi().createButton("RunsG8Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G8','up']);
		webiopi().callMacro("get_counter_value", 'G8', getRunsG8);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG8.append(runsG8_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG8Button = webiopi().createButton("RunsG8", "---", getRunsG8);
	contentG8.append(showRunsG8Button);
	
	var runsG8_MinusButton = webiopi().createButton("RunsG8Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G8','down']);
		webiopi().callMacro("get_counter_value", 'G8', getRunsG8);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG8.append(runsG8_MinusButton);

	// Functions needed by the current runs text
	function getRunsG8() {
		webiopi().callMacro("get_counter_value", 'G8', setRunsG8);
	}
	function setRunsG8(macro, args, data) {
		webiopi().setLabel("RunsG8", data);
	}

	// ############################### Runs Gast, 9. Inning ################################

	var contentG9;
	contentG9 = $("#contentG9");

	var runsG9_PlusButton = webiopi().createButton("RunsG9Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['G9','up']);
		webiopi().callMacro("get_counter_value", 'G9', getRunsG9);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG9.append(runsG9_PlusButton);

	// Dummy button to hold the current runs
	var showRunsG9Button = webiopi().createButton("RunsG9", "---", getRunsG9);
	contentG9.append(showRunsG9Button);
	
	var runsG9_MinusButton = webiopi().createButton("RunsG9Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['G9','down']);
		webiopi().callMacro("get_counter_value", 'G9', getRunsG9);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
	});
	contentG9.append(runsG9_MinusButton);

	// Functions needed by the current runs text
	function getRunsG9() {
		webiopi().callMacro("get_counter_value", 'G9', setRunsG9);
	}
	function setRunsG9(macro, args, data) {
		webiopi().setLabel("RunsG9", data);
	}

	// ############################## Runs Gast, Extra Innings ##############################
	// No update buttons, just the dummy button displaying the runs
	var contentGX;
	contentGX = $("#contentGX");

	// Dummy button to hold the current runs
	var showRunsGXButton = webiopi().createButton("RunsGX", "---", getRunsGX);
	contentGX.append(showRunsGXButton);
	
	// Functions needed by the current runs text
	function getRunsGX() {
		webiopi().callMacro("get_counter_value", 'GX', setRunsGX);
	}
	function setRunsGX(macro, args, data) {
		webiopi().setLabel("RunsGX", data);
	}

	// ################################# Runs Gast, Total  ##################################
	// No update buttons, just the dummy button displaying the runs
	var contentGR;
	contentGR = $("#contentGR");

	// Dummy button to hold the current runs
	var showRunsGRButton = webiopi().createButton("RunsGR", "---", getRunsGR);
	contentGR.append(showRunsGRButton);
	
	// Functions needed by the current runs text
	function getRunsGR() {
		webiopi().callMacro("get_counter_value", 'GR', setRunsGR);
	}
	function setRunsGR(macro, args, data) {
		webiopi().setLabel("RunsGR", data);
	}

	// ##################################### Hits Gast ######################################

	var contentGH;
	contentGH = $("#contentGH");

	var hitsG_PlusButton = webiopi().createButton("HitsGUp", "+", function() {
		webiopi().callMacro("update_given_hits_count",['G','up']);
		webiopi().callMacro("get_counter_value", 'GH', getHitsG);
	});
	contentGH.append(hitsG_PlusButton);

	// Dummy button to hold the current hits
	var showHitsGButton = webiopi().createButton("HitsG", "---", getHitsG);
	contentGH.append(showHitsGButton);
	
	var hitsG_MinusButton = webiopi().createButton("HitsGDown", "–", function() {
		webiopi().callMacro("update_given_hits_count",['G','down']);
		webiopi().callMacro("get_counter_value", 'GH', getHitsG);
	});
	contentGH.append(hitsG_MinusButton);

	// Functions needed by the current hits text
	function getHitsG() {
		webiopi().callMacro("get_counter_value", 'GH', setHitsG);
	}
	function setHitsG(macro, args, data) {
		webiopi().setLabel("HitsG", data);
	}

	// #################################### Errors Gast ####################################

	var contentGE;
	contentGE = $("#contentGE");

	var errorsG_PlusButton = webiopi().createButton("ErrGUp", "+", function() {
		webiopi().callMacro("update_given_error_count",['GE','up']);
		webiopi().callMacro("get_counter_value", 'GE', getErrorsG);
	});
	contentGE.append(errorsG_PlusButton);

	// Dummy button to hold the current errors
	var showErrorsGButton = webiopi().createButton("ErrG", "---", getErrorsG);
	contentGE.append(showErrorsGButton);
	
	var errorsG_MinusButton = webiopi().createButton("ErrGDown", "–", function() {
		webiopi().callMacro("update_given_error_count",['GE','down']);
		webiopi().callMacro("get_counter_value", 'GE', getErrorsG);
	});
	contentGE.append(errorsG_MinusButton);

	// Functions needed by the current errors text
	function getErrorsG() {
		webiopi().callMacro("get_counter_value", 'GE', setErrorsG);
	}
	function setErrorsG(macro, args, data) {
		webiopi().setLabel("ErrG", data);
	}


	// ############################### Runs Heim, 1. Inning ################################

	var contentH1;
	contentH1 = $("#contentH1");

	var runsH1_PlusButton = webiopi().createButton("RunsH1Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H1','up']);
		webiopi().callMacro("get_counter_value", 'H1', getRunsH1);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH1.append(runsH1_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH1Button = webiopi().createButton("RunsH1", "---", getRunsH1);
	contentH1.append(showRunsH1Button);
	
	var runsH1_MinusButton = webiopi().createButton("RunsH1Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H1','down']);
		webiopi().callMacro("get_counter_value", 'H1', getRunsH1);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH1.append(runsH1_MinusButton);

	// Functions needed by the current runs text
	function getRunsH1() {
		webiopi().callMacro("get_counter_value", 'H1', setRunsH1);
	}
	function setRunsH1(macro, args, data) {
		webiopi().setLabel("RunsH1", data);
	}

	// ############################### Runs Heim, 2. Inning ################################

	var contentH2;
	contentH2 = $("#contentH2");

	var runsH2_PlusButton = webiopi().createButton("RunsH2Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H2','up']);
		webiopi().callMacro("get_counter_value", 'H2', getRunsH2);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH2.append(runsH2_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH2Button = webiopi().createButton("RunsH2", "---", getRunsH2);
	contentH2.append(showRunsH2Button);
	
	var runsH2_MinusButton = webiopi().createButton("RunsH2Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H2','down']);
		webiopi().callMacro("get_counter_value", 'H2', getRunsH2);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH2.append(runsH2_MinusButton);

	// Functions needed by the current runs text
	function getRunsH2() {
		webiopi().callMacro("get_counter_value", 'H2', setRunsH2);
	}
	function setRunsH2(macro, args, data) {
		webiopi().setLabel("RunsH2", data);
	}

	// ############################### Runs Heim, 3. Inning ################################

	var contentH3;
	contentH3 = $("#contentH3");

	var runsH3_PlusButton = webiopi().createButton("RunsH3Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H3','up']);
		webiopi().callMacro("get_counter_value", 'H3', getRunsH3);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH3.append(runsH3_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH3Button = webiopi().createButton("RunsH3", "---", getRunsH3);
	contentH3.append(showRunsH3Button);
	
	var runsH3_MinusButton = webiopi().createButton("RunsH3Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H3','down']);
		webiopi().callMacro("get_counter_value", 'H3', getRunsH3);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH3.append(runsH3_MinusButton);

	// Functions needed by the current runs text
	function getRunsH3() {
		webiopi().callMacro("get_counter_value", 'H3', setRunsH3);
	}
	function setRunsH3(macro, args, data) {
		webiopi().setLabel("RunsH3", data);
	}

	// ############################### Runs Heim, 4. Inning ################################

	var contentH4;
	contentH4 = $("#contentH4");

	var runsH4_PlusButton = webiopi().createButton("RunsH4Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H4','up']);
		webiopi().callMacro("get_counter_value", 'H4', getRunsH4);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH4.append(runsH4_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH4Button = webiopi().createButton("RunsH4", "---", getRunsH4);
	contentH4.append(showRunsH4Button);
	
	var runsH4_MinusButton = webiopi().createButton("RunsH4Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H4','down']);
		webiopi().callMacro("get_counter_value", 'H4', getRunsH4);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH4.append(runsH4_MinusButton);

	// Functions needed by the current runs text
	function getRunsH4() {
		webiopi().callMacro("get_counter_value", 'H4', setRunsH4);
	}
	function setRunsH4(macro, args, data) {
		webiopi().setLabel("RunsH4", data);
	}

	// ############################### Runs Heim, 5. Inning ################################

	var contentH5;
	contentH5 = $("#contentH5");

	var runsH5_PlusButton = webiopi().createButton("RunsH5Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H5','up']);
		webiopi().callMacro("get_counter_value", 'H5', getRunsH5);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH5.append(runsH5_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH5Button = webiopi().createButton("RunsH5", "---", getRunsH5);
	contentH5.append(showRunsH5Button);
	
	var runsH5_MinusButton = webiopi().createButton("RunsH5Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H5','down']);
		webiopi().callMacro("get_counter_value", 'H5', getRunsH5);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH5.append(runsH5_MinusButton);

	// Functions needed by the current runs text
	function getRunsH5() {
		webiopi().callMacro("get_counter_value", 'H5', setRunsH5);
	}
	function setRunsH5(macro, args, data) {
		webiopi().setLabel("RunsH5", data);
	}

	// ############################### Runs Heim, 6. Inning ################################

	var contentH6;
	contentH6 = $("#contentH6");

	var runsH6_PlusButton = webiopi().createButton("RunsH6Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H6','up']);
		webiopi().callMacro("get_counter_value", 'H6', getRunsH6);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH6.append(runsH6_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH6Button = webiopi().createButton("RunsH6", "---", getRunsH6);
	contentH6.append(showRunsH6Button);
	
	var runsH6_MinusButton = webiopi().createButton("RunsH6Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H6','down']);
		webiopi().callMacro("get_counter_value", 'H6', getRunsH6);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH6.append(runsH6_MinusButton);

	// Functions needed by the current runs text
	function getRunsH6() {
		webiopi().callMacro("get_counter_value", 'H6', setRunsH6);
	}
	function setRunsH6(macro, args, data) {
		webiopi().setLabel("RunsH6", data);
	}

	// ############################### Runs Heim, 7. Inning ################################

	var contentH7;
	contentH7 = $("#contentH7");

	var runsH7_PlusButton = webiopi().createButton("RunsH7Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H7','up']);
		webiopi().callMacro("get_counter_value", 'H7', getRunsH7);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH7.append(runsH7_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH7Button = webiopi().createButton("RunsH7", "---", getRunsH7);
	contentH7.append(showRunsH7Button);
	
	var runsH7_MinusButton = webiopi().createButton("RunsH7Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H7','down']);
		webiopi().callMacro("get_counter_value", 'H7', getRunsH7);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH7.append(runsH7_MinusButton);

	// Functions needed by the current runs text
	function getRunsH7() {
		webiopi().callMacro("get_counter_value", 'H7', setRunsH7);
	}
	function setRunsH7(macro, args, data) {
		webiopi().setLabel("RunsH7", data);
	}

	// ############################### Runs Heim, 8. Inning ################################

	var contentH8;
	contentH8 = $("#contentH8");

	var runsH8_PlusButton = webiopi().createButton("RunsH8Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H8','up']);
		webiopi().callMacro("get_counter_value", 'H8', getRunsH8);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH8.append(runsH8_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH8Button = webiopi().createButton("RunsH8", "---", getRunsH8);
	contentH8.append(showRunsH8Button);
	
	var runsH8_MinusButton = webiopi().createButton("RunsH8Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H8','down']);
		webiopi().callMacro("get_counter_value", 'H8', getRunsH8);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH8.append(runsH8_MinusButton);

	// Functions needed by the current runs text
	function getRunsH8() {
		webiopi().callMacro("get_counter_value", 'H8', setRunsH8);
	}
	function setRunsH8(macro, args, data) {
		webiopi().setLabel("RunsH8", data);
	}

	// ############################### Runs Heim, 9. Inning ################################

	var contentH9;
	contentH9 = $("#contentH9");

	var runsH9_PlusButton = webiopi().createButton("RunsH9Up", "+", function() {
		webiopi().callMacro("update_given_run_counter",['H9','up']);
		webiopi().callMacro("get_counter_value", 'H9', getRunsH9);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH9.append(runsH9_PlusButton);

	// Dummy button to hold the current runs
	var showRunsH9Button = webiopi().createButton("RunsH9", "---", getRunsH9);
	contentH9.append(showRunsH9Button);
	
	var runsH9_MinusButton = webiopi().createButton("RunsH9Down", "–", function() {
		webiopi().callMacro("update_given_run_counter",['H9','down']);
		webiopi().callMacro("get_counter_value", 'H9', getRunsH9);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
	});
	contentH9.append(runsH9_MinusButton);

	// Functions needed by the current runs text
	function getRunsH9() {
		webiopi().callMacro("get_counter_value", 'H9', setRunsH9);
	}
	function setRunsH9(macro, args, data) {
		webiopi().setLabel("RunsH9", data);
	}

	// ############################## Runs Heim, Extra Innings ##############################
	// No update buttons, just the dummy button displaying the runs
	var contentHX;
	contentHX = $("#contentHX");

	// Dummy button to hold the current runs
	var showRunsHXButton = webiopi().createButton("RunsHX", "---", getRunsHX);
	contentHX.append(showRunsHXButton);
	
	// Functions needed by the current runs text
	function getRunsHX() {
		webiopi().callMacro("get_counter_value", 'HX', setRunsHX);
	}
	function setRunsHX(macro, args, data) {
		webiopi().setLabel("RunsHX", data);
	}

	// ################################# Runs Heim, Total  ##################################
	// No update buttons, just the dummy button displaying the runs
	var contentHR;
	contentHR = $("#contentHR");

	// Dummy button to hold the current runs
	var showRunsHRButton = webiopi().createButton("RunsHR", "---", getRunsHR);
	contentHR.append(showRunsHRButton);
	
	// Functions needed by the current runs text
	function getRunsHR() {
		webiopi().callMacro("get_counter_value", 'HR', setRunsHR);
	}
	function setRunsHR(macro, args, data) {
		webiopi().setLabel("RunsHR", data);
	}

	// ##################################### Hits Heim ######################################

	var contentHH;
	contentHH = $("#contentHH");

	var hitsH_PlusButton = webiopi().createButton("HitsHUp", "+", function() {
		webiopi().callMacro("update_given_hits_count",['H','up']);
		webiopi().callMacro("get_counter_value", 'HH', getHitsH);
	});
	contentHH.append(hitsH_PlusButton);

	// Dummy button to hold the current hits
	var showHitsHButton = webiopi().createButton("HitsH", "---", getHitsH);
	contentHH.append(showHitsHButton);
	
	var hitsH_MinusButton = webiopi().createButton("HitsHDown", "–", function() {
		webiopi().callMacro("update_given_hits_count",['H','down']);
		webiopi().callMacro("get_counter_value", 'HH', getHitsH);
	});
	contentHH.append(hitsH_MinusButton);

	// Functions needed by the current hits text
	function getHitsH() {
		webiopi().callMacro("get_counter_value", 'HH', setHitsH);
	}
	function setHitsH(macro, args, data) {
		webiopi().setLabel("HitsH", data);
	}

	// #################################### Errors Heim ####################################

	var contentHE;
	contentHE = $("#contentHE");

	var errorsH_PlusButton = webiopi().createButton("ErrHUp", "+", function() {
		webiopi().callMacro("update_given_error_count",['HE','up']);
		webiopi().callMacro("get_counter_value", 'HE', getErrorsH);
	});
	contentHE.append(errorsH_PlusButton);

	// Dummy button to hold the current errors
	var showErrorsHButton = webiopi().createButton("ErrH", "---", getErrorsH);
	contentHE.append(showErrorsHButton);
	
	var errorsH_MinusButton = webiopi().createButton("ErrHDown", "–", function() {
		webiopi().callMacro("update_given_error_count",['HE','down']);
		webiopi().callMacro("get_counter_value", 'HE', getErrorsH);
	});
	contentHE.append(errorsH_MinusButton);

	// Functions needed by the current errors text
	function getErrorsH() {
		webiopi().callMacro("get_counter_value", 'HE', setErrorsH);
	}
	function setErrorsH(macro, args, data) {
		webiopi().setLabel("ErrH", data);
	}

	// #####################################################################################
	// ############################### Display mode section ################################
	// #####################################################################################

	// Button 0 - Time mode
	var contentMode0;
	contentMode0 = $("#contentMode0");

	var mode0Button = webiopi().createButton("Mode0", " ", function() {
		webiopi().callMacro("set_display_mode",'0');
		webiopi().callMacro("get_display_mode", [], getDispMode);
	});
	contentMode0.append(mode0Button);

	function getDispMode() {
		webiopi().callMacro("get_display_mode", [], setLabelD0);
		webiopi().callMacro("get_display_mode", [], setLabelD1);
		webiopi().callMacro("get_display_mode", [], setLabelD2);
	}
	function setLabelD0(macro, args, data) {
		if (data == 0)
		{
			webiopi().setLabel("Mode0", "X");
		} else {
			webiopi().setLabel("Mode0", " ");
		}
	}

	// Button 1 - Baseball mode
	var contentMode1;
	contentMode1 = $("#contentMode1");

	var mode1Button = webiopi().createButton("Mode1", "X", function() {
		webiopi().callMacro("set_display_mode",'1');
		webiopi().callMacro("get_display_mode", [], getDispMode);
	});
	contentMode1.append(mode1Button);

	function getDispMode() {
		webiopi().callMacro("get_display_mode", [], setLabelD0);
		webiopi().callMacro("get_display_mode", [], setLabelD1);
		webiopi().callMacro("get_display_mode", [], setLabelD2);
	}
	function setLabelD1(macro, args, data) {
		if (data == 1)
		{
			webiopi().setLabel("Mode1", "X");
		} else {
			webiopi().setLabel("Mode1", " ");
		}
	}

	// Button 2 - Teeball mode
	var contentMode2;
	contentMode2 = $("#contentMode2");

	var mode2Button = webiopi().createButton("Mode2", " ", function() {
		webiopi().callMacro("set_display_mode",'2');
		webiopi().callMacro("get_display_mode", [], getDispMode);
	});
	contentMode2.append(mode2Button);

	function getDispMode() {
		webiopi().callMacro("get_display_mode", [], setLabelD0);
		webiopi().callMacro("get_display_mode", [], setLabelD1);
		webiopi().callMacro("get_display_mode", [], setLabelD2);
	}
	function setLabelD2(macro, args, data) {
		if (data == 2)
		{
			webiopi().setLabel("Mode2", "X");
		} else {
			webiopi().setLabel("Mode2", " ");
		}
	}

	// #####################################################################################
	// ############################### Game control section ################################
	// #####################################################################################

	// ################################# Start a new game ##################################
	var contentNewGame;
	contentNewGame = $("#contentNewGame");

	var newGameButton = webiopi().createButton("NewGame", "Neues Spiel beginnen", function() {
		var newGameResponse = confirm("Neues Spiel beginnen? Alle Zähler werden zurückgesetzt!");
		if (newGameResponse == true) {
			webiopi().callMacro("start_new_game", []);
			window.location.reload(true);
		} 
	});
	contentNewGame.append(newGameButton);

	// ################################### Set the clock ###################################
	var contentSetClock;
	contentSetClock = $("#contentSetClock");

	var setTimeButton = webiopi().createButton("SetClock", "Zeit stellen", function() {
		var setTimeResponse = prompt("Gib die aktuelle Zeit ein. Du musst dieses Format verwenden: \n12:22.", "hh:mm");
		if (setTimeResponse != null) {
			webiopi().callMacro("set_time", setTimeResponse);
		}
	});
	contentSetClock.append(setTimeButton);

	// ############################# Restart the scoreboard ################################
	var contentRestart;
	contentRestart = $("#contentRestart");

	var restartButton = webiopi().createButton("Restart", "Scoreboard neu starten", function() {
		var restartResponse = confirm("Scoreboard neu starten? Alle Zeiger und Einstellungen gehen verloren und die Verbindung zum Browser wird für ein paar Minuten nicht verfügbar sein.");
		if (restartResponse == true) {
			webiopi().callMacro("restart_scoreboard", []);
		} 
	});
	contentRestart.append(restartButton);


	// ############################ Shut down the scoreboard ###############################
	var contentShutdown;
	contentShutdown = $("#contentShutdown");

	var shutdownButton = webiopi().createButton("Shutdown", "Scoreboard abschalten", function() {
		var shutdownResponse = confirm("Scoreboard komplett abschalten? Du musst den Hauptschalter am Scoreboard aus- und einschalten um das Scoreboard wieder zu verwenden.");
		if (shutdownResponse == true) {
			webiopi().callMacro("shutdown_scoreboard", []);
		} 
	});
	contentShutdown.append(shutdownButton);


	// ############# Refresh all label buttons if user refreshes the page ##################
	// ############# Also attempt to set the pi's time from the client #####################

	$(document).ready(function(){
		webiopi().callMacro("get_counter_value", 'G1', getRunsG1);
		webiopi().callMacro("get_counter_value", 'G2', getRunsG2);
		webiopi().callMacro("get_counter_value", 'G3', getRunsG3);
		webiopi().callMacro("get_counter_value", 'G4', getRunsG4);
		webiopi().callMacro("get_counter_value", 'G5', getRunsG5);
		webiopi().callMacro("get_counter_value", 'G6', getRunsG6);
		webiopi().callMacro("get_counter_value", 'G7', getRunsG7);
		webiopi().callMacro("get_counter_value", 'G8', getRunsG8);
		webiopi().callMacro("get_counter_value", 'G9', getRunsG9);
		webiopi().callMacro("get_counter_value", 'GX', getRunsGX);
		webiopi().callMacro("get_counter_value", 'GR', getRunsGR);
		webiopi().callMacro("get_counter_value", 'GH', getHitsG);
		webiopi().callMacro("get_counter_value", 'GE', getErrorsG);
		webiopi().callMacro("get_counter_value", 'H1', getRunsH1);
		webiopi().callMacro("get_counter_value", 'H2', getRunsH2);
		webiopi().callMacro("get_counter_value", 'H3', getRunsH3);
		webiopi().callMacro("get_counter_value", 'H4', getRunsH4);
		webiopi().callMacro("get_counter_value", 'H5', getRunsH5);
		webiopi().callMacro("get_counter_value", 'H6', getRunsH6);
		webiopi().callMacro("get_counter_value", 'H7', getRunsH7);
		webiopi().callMacro("get_counter_value", 'H8', getRunsH8);
		webiopi().callMacro("get_counter_value", 'H9', getRunsH9);
		webiopi().callMacro("get_counter_value", 'HX', getRunsHX);
		webiopi().callMacro("get_counter_value", 'HR', getRunsHR);
		webiopi().callMacro("get_counter_value", 'HH', getHitsH);
		webiopi().callMacro("get_counter_value", 'HE', getErrorsH);
		webiopi().callMacro("get_counter_value", 'BALLS', setBalls);
		webiopi().callMacro("get_counter_value", 'STRIKES', setStrikes);
		webiopi().callMacro("get_counter_value", 'OUTS', setOuts);
		webiopi().callMacro("get_display_mode", [], setLabelD0);
		webiopi().callMacro("get_display_mode", [], setLabelD1);
		webiopi().callMacro("get_display_mode", [], setLabelD2);

		var DateTime = new Date();
		var strHours = DateTime.getHours();
		var strMinutes = DateTime.getMinutes();
		if (DateTime != null) {
			webiopi().callMacro("set_time", strHours + ":" + strMinutes);
		}

	});

});
